<?php

namespace Lucent\Query\BuilderConverter;

use Illuminate\Database\Query\Builder;
use Lucent\Query\Filter\Argument;

readonly class NotEquals implements IBuilderConverter
{

    public function __construct(private Argument $argument)
    {
    }

    public function toAndQueryBuilder(Builder $builder): Builder
    {
        return $builder->whereNot($this->argument->field, $this->formatValue());
    }

    public function toOrQueryBuilder(Builder $builder): Builder
    {
        return $builder->orWhereNot($this->argument->field,  $this->formatValue());
    }

    private function formatValue(): string
    {
        return trim($this->argument->value);
    }
}